#ifndef ClientAmaBoard_H
#define ClientAmaBoard_H

#include "ClientBoard.H"
#include "AmaClientBoardType.H"

class AmaClientBoard : public ClientBoard {
  
private:

  bool on_same_line(int ind1, int ind2) const;
  bool empty_line(sint4 ind1, sint4 ind2) const;
 
  AmaClientBoard &operator=(const AmaClientBoard &x) {
    ERR("private operator=");
    return *this;
  }

  void init() { white_passes = 0; }
    
public:

  enum { HIT = 4 };  // additional square contents

  sint4 white_passes;

  
  AmaClientBoard() { init(); type = new AmaClientBoardType(); }

  AmaClientBoard(sint4 t) { init(); type = new AmaClientBoardType(t); }  

  AmaClientBoard(const AmaClientBoard &x) { copy_of(x); }

  void copy_of(const AmaClientBoard &x) {
    ClientBoard::copy_of(x);
    white_passes = x.white_passes;
  }

  AmaClientBoard *clone() const { return new AmaClientBoard(*this); }

  void  setup();
  bool  make_move(const ClientMove &mv);
  bool  is_finished() const;
  sint4 char2cont(char c) const;
  sint1 cont2char(sint4 cont) const;  
  bool no_opponent_moves();

};

#endif

