#ifndef AmaClientBoardType_H
#define AmaClientBoardType_H

#include "ClientIncludes.H"
#include "ClientBoardType.H"

class AmaClientBoardType : public ClientBoardType {

private:

  AmaClientBoardType &operator=(const AmaClientBoardType &x) {
    copy_of(x);
    return *this;
  }
 
public:

  AmaClientBoardType(sint4 t=-1) {

    types.erase(types.begin(), types.end());
    names.erase(names.begin(), names.end());

    TYPE_DEFAULT = 10;
    
    FORS (i, 6) {
      types.push_back(4 + 2*i);
      String s; s.form("%dx%d", types[i], types[i]);
      names.push_back(s);
    }

    if (t < 0) bt = TYPE_DEFAULT;
    else       bt = t;
    if (get_type_index() < 0) ERR("illegal board type");
  }

  AmaClientBoardType(const AmaClientBoardType &x) { copy_of(x); }

  void copy_of(const ClientBoardType &x) {
    ClientBoardType::copy_of(x);
  }
 
  ClientBoardType *clone() const { return new AmaClientBoardType(*this); }

  sint4 board_width() const {
    return bt;
  }
  
  sint4 board_squares() const {
    return bt*bt;
  }
 

};


#endif

