#ifndef AmaClientMove_H
#define AmaClientMove_H

#include "ClientMove.H"

class AmaClientMove : public ClientMove
{

private:
  
  sint4 from, to, arrow;    // base Client::BoardType::DX

public:

  AmaClientMove() { init(UNDEF, UNDEF, UNDEF); }

  AmaClientMove(const AmaClientMove &x) { copy_of(x); }

  AmaClientMove &operator=(const AmaClientMove &x) {
    copy_of(x);
    return *this;
  }

  friend bool operator==(const AmaClientMove &mv1, const AmaClientMove &mv2);
  
  void copy_of(const ClientMove &x) {
    ClientMove::copy_of(x);
    const AmaClientMove &y = dynamic_cast<const AmaClientMove&>(x);
    from  = y.from;
    to    = y.to;
    arrow = y.arrow;    
  }

  ClientMove *clone() const { return new AmaClientMove(*this); }

  sint4 get_from() const  { return from; }
  sint4 get_to()   const  { return to; }
  sint4 get_arrow() const { return arrow; }   
  void set_arrow(sint4 ar) { arrow = ar; }
  
  bool   is_pass() const { return false; }
  
  void   init(int c1, int c2, int c3) { from = c1; to = c2; arrow = c3; }
  String coords2str() const;
  String str2coords(String &s);
  bool   is_valid() const;

  friend class AmaClientBoard;

};

inline bool operator==(const AmaClientMove &mv1, const AmaClientMove &mv2) {
  if (mv1.from != mv2.from)   return false;
  if (mv1.to   != mv2.to)     return false;
  if (mv1.arrow != mv2.arrow) return false;
  return true;
}

extern bool comp(const AmaClientMove &mv1, const AmaClientMove &mv2);

#endif

