/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef AxClientBoardType_H
#define AxClientBoardType_H

#include "ClientIncludes.H"
#include "ClientBoardType.H"

class AxClientBoardType : public ClientBoardType
{

public:

  AxClientBoardType() {

    types.erase(types.begin(), types.end());
    names.erase(names.begin(), names.end());

    TYPE_DEFAULT = 7;
    
    FORS (i, 11) {
      types.push_back(4 + i);
      String s; s.form("%dx%d", types[i], types[i]);
      names.push_back(s);
    }

    bt = TYPE_DEFAULT;
    if (get_type_index() < 0) ERR("illegal default board type");
  }

  AxClientBoardType(const AxClientBoardType &x) { *this = x; }

  AxClientBoardType &operator=(const AxClientBoardType &x) {
    ((ClientBoardType*)this)->operator=((ClientBoardType&)x);
    return *this; 
  }
  
  ClientBoardType *clone() const { return new AxClientBoardType(*this); }

  sint4 board_width() const {
    return bt;
  }
  
  sint4 board_squares() const {
    return bt*bt;
  }
 

};


#endif

