/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef CksClientMove_H
#define CksClientMove_H

#include "ClientMove.H"

class CksClientMove : public ClientMove
{
public:
  
  typedef vector<sint4> MoveSeq;

private:
  
  MoveSeq ms;  // base Client::BoardType::DX

  CksClientMove &operator=(const CksClientMove &x) {
    ERR("private operator=");
  }
  
public:

  
  CksClientMove(sint4 s = PASS) { ms.push_back(s); }

  CksClientMove(const CksClientMove &x) { copy_of(x); }

  void copy_of(const ClientMove &x) {
    ClientMove::copy_of(x);
    const CksClientMove &y = dynamic_cast<const CksClientMove&>(x);
    ms = y.ms;
  }

  ClientMove *clone() const { return new CksClientMove(*this); }

  void get_coords(MoveSeq &move_seq) const { move_seq = ms; }

  // sint4 get_sq() const { return sq; } 
  
  // bool is_pass() const { return sq == PASS; }
  
  // void init(int c1, int c2, int c3) { sq = c1; }; 

  String coords2str() const;
  String str2coords(String &s);
  bool   is_valid() const;

  friend class CksClientBoard;
};


#endif

