/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// you can test the client by starting a self-game and issuing
// moves manually:
//                                           or by using aliases:
//      "verbose"                            (type "A" for definitions)
//
//                                           ms (service) 
//  tell (service) ask 8 15 client           ts ask 8 15 client 
//  tell (service) play .<game-id> move1     sm .<game-id>
//  ...                                      tpm move1
//                                           tpm move2
//                                           ...
//
// (service) = /os /ams or /cks for the moment
  

#include <unistd.h>

static bool analyse = false;

int main()
{
  CLIENT client("external.nj.nec.com", 5000, "client", "clientpw");

  client.add_super_user("mic");

  // set service variable "client" to + (needed for this client to work)
  
  client.send("tell " + client.service_login() + " client +\n");

  // set service variable "open" to 1 (client accepts match requests)

  client.send("tell " + client.service_login() + " open 1\n");

  client.send("who\n");

  for (;;) {

    client.io();

    if (client.state() != Client::UNDEF) {
      
      if (client.state() == Client::REMOTE_CMD) {
	
	cout << "REMOTE cmd received from '"
	     << client.remote.sender
	     << "': "
	     << client.remote.msg[0]
	     << endl;
	
	String msg = "tell " + client.tell.sender + " issued your command\n";
	client.send(msg);
	client.send(client.remote.msg[0]+"\n");
	
      } else if (client.state() == Client::INTERNAL_CMD) {
	
	if (client.internal.msg == "analyse") {
	  
	  analyse = !analyse;
	  cout << "set analyse = " << analyse << endl;
	  
	} else {
	  
	  client.send(client.internal.msg + "\n");
	}

      }
      
      client.reset();
    }
    
    usleep( 100000 );
  }
  
  return 0;
};


