/*
    (c) Michael Buro

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



// Log. code fragment which illustrates how to handle
// JOIN and UPDATE

// Message(s) sends s+'\n' to the server

#define FORT(i,n) for (typeof(n) i=0; i < (n); i++)

#include "OthClient.H"

OthClient *client = 0;

static void Message(const String &s)
{
  String msg = s; msg += '\n';
  cout << "MESSAGE: " << s << endl;
  client->send(msg);
}

int main()
{  
  ...
  client = new OthClient(server, port, login, passwd);
  ...
}



void signal_check()
{
  ...

 client->io();
 sint4 type = client->state();

 if (type == Client::JOIN || type == Client::UPDATE) {

   printf("SIG_JOIN | SIG_UPDATE\n");

   String id;
      
   if (type == Client::JOIN) id = client->join.id; else id = client->update.id;

   // get access to the game information
   const OthClientGame *cgame = (OthClientGame*)client->get_game(id);

   if (!cgame) Error("SIG_JOIN: game not found!");

   // check whether you are involved in that game
   
   if (cgame->pinf[0].name != client->login() &&
       cgame->pinf[1].name != client->login())
     goto reset;

   String msg = "tell /os break ";
   msg += id;

   // not 8x8 or anti -> break
   // how the hell did you accept those games in the first place?
      
   if (cgame->get_type().get_board_type().get_code() != 8 ||
       cgame->get_type().is_anti_game()) {
     Message(msg);
     goto reset;
   }

#if 0   
   if (type == Client::JOIN && !cgame->get_type().is_rand_game()) {

     // regular game started -> convert ClientGame into ancient format (Game)

     Board tab;
     StartPos(&tab); tab.to_move = BLACK; 

     FORT (i, cgame->moves.size()) {
       const OthClientMove &mv =
	 dynamic_cast<const OthClientMove&>(*(cgame->moves[i]));
       sint4 x = ClientBoard::ind2x(mv.get_sq());
       sint4 y = ClientBoard::ind2y(mv.get_sq());	  
       sint4 ind = x+1 + 10 * (y+1);
       tab.p[ind] = i+1 + NUM_DISP;
     }

     Board2Game(&tab, &Game);
     fWriteGame(stdout, &Game);
   }
#endif

   // find out whether it's my move
   // I am to move when it is the first move in komi games
   // or name_to_move() matches
   
   if (!cgame->get_moves().size() == 0 ||
       !cgame->type.is_komi_game()) 
     if (cgame->name_to_move() != client->login()) goto reset;  // not my turn
 
   // convert current position into ancient board format (board)

   const OthClientBoard &bo =
     dynamic_cast<const OthClientBoard&>(*(cgame->curr_pos));
      
   board = board0;  // empty board (10x10 bytes)

   FORT (y, 8) {
     FORT (x, 8) {

       sint4 ind = ClientBoard::xy2ind(x, y);
       sint4 i = Tab8to10[x+y*8];
	  
       switch (bo.get_sq_cont(ind)) {
       case ClientBoard::BLACK : board.p[i] = BLACK; break;
       case ClientBoard::WHITE : board.p[i] = WHITE; break;
       case ClientBoard::EMPTY : board.p[i] = EMPTY; break;
       case ClientBoard::BORDER: board.p[i] = BORDER; break;
	 ... addi
       default: Error("illegal board entry"); break;
       }
     }
   }


#if 0   
   if (cgame->moves.size() > 0) {

     // convert last move 
    
     const OthClientMove &cm =
       dynamic_cast<const OthClientMove&>(*(cgame->moves.back()));

     if (cm.is_pass()) last_move = MOVE_PASS;
     else {
       sint4 x = ClientBoard::ind2x(cm.get_sq());
       sint4 y = ClientBoard::ind2y(cm.get_sq());	  
       last_move = x+1 + 10* (y+1);
     }
	  
   } else {

     last_move = MOVE_UNKNOWN;

   }
#endif

   
   // which color is to move?

   sint4 color_to_move;
   
   if (bo.get_to_move() == ClientColor::BLACK)
     color_to_move = BLACK;
   else
     color_to_move = WHITE;

   printf(">>> board_komi=%f board_rand=%d\n",
	  cgame->komi,
	  cgame->get_type().get_rand_type()
	  );

   // remaining thinking time

   int ind = cgame->name_index(client->login());
   int remaining_seconds_left = cgame->pinf[ind].clock.time_left(false) / uSec;

   received_msg = true; n = SIG_BOARD;

   // compute move...

to send moves to GGS:

client.send("tell " + client.service_login() + " play " + id + " " +
	    best_move.to_string() +
optional:    "/" + eval + "/" + time +
	    "\n");

where id is the game-id and best_move contains the move to be sent.

   
 reset: ;
   
   client->reset();
 }

 ...
 
						       }
